<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta content="width=device-width, initial-scale=1.0" name="viewport">
        <title>Merged Cells</title>
        <style>
            body { font-family: sans-serif; }
            h1 {
                text-align: center;
                background-color: #eee;
            }
            table {
                border-collapse: collapse;
                width: 100%;
            }
            th { padding: 0.5em 0.1em; }
            td { padding: 0.2em 0.1em; }

            td:nth-last-child(1), 
            td:nth-last-child(2), 
            td:nth-last-child(3) {
                width: 6em;
            }

            thead th {
                text-align: left;
                vertical-align: top;
            }
            thead td {
                text-align: right;
                vertical-align: top;
            }
            thead tr:nth-child(3) td {
                text-align: left;
                line-height: 1.5;
            }

            tbody {
                border: 1px solid #aaa;
            }
            tbody tr :nth-child(n) {
                text-align: right;
            }
            tbody tr :nth-child(2) {
                text-align: center;
            }
            tbody tr :first-child {
                text-align: left;
            }

            tfoot {
                border: 1px solid #aaa;
            }
            tfoot tr :first-child {
                text-align: left;
            }
            tfoot tr :last-child {
                text-align: right;
                border-left: 1px dotted #555;
            }
            tfoot th {
                background-color: #eee;
            }
            tfoot tr + tr {
                border-top: 1px dashed #555;
            }
        </style>
    </head>
    <body>
        <h1>Invoice</h1>

        <table>
            <thead>
                <tr>
                    <th colspan="3" rowspan="2">Invoice No. &amp; Date</th>
                    <td colspan="2">123-456789</td>
                </tr>
                <tr> <td colspan="2">August 12, 2019</td> </tr>
                <tr>
                    <td colspan="2">
                        <strong>Customer:</strong><br/>
                        Defects Multiplier, Inc.<br/>
                        <address> 42 Reboot Lane<br/> Perl Lake, PWA 17 </address>
                    </td>
                    <td colspan="3">
                        <strong>Delivery Address:</strong><br/>
                        <address> 17 Hacker Street<br/>Javaville, USB 123 </address>
                    </td>
                </tr>
            </thead>
            <tbody>
                <tr> <th>Article</th> <th>Qty.</th> <th>Price</th> <th>Discount</th> <th>Cost</th> </tr>
            </tbody>
            <tfoot>
                <tr> <th colspan="4">Subtotal</th> <td id="subtotal"></td> </tr>
                <tr> <th colspan="3">VAT</th> <td id="vatPercent"></td> <td id="vatAmount"></td> </tr>
                <tr> <th colspan="4">Grand Total</th> <td id="total"></td> </tr>
            </tfoot>
        </table>

        <script>
            const cart = [
                { article: 'Apple', count: 5, price: 1.5, discount: 0 }, 
                { article: 'Banana', count: 3, price: 0.75, discount: 10 }, 
                { article: 'Coco Nut', count: 2, price: 1.85, discount: 16 },
                { article: 'Date Plum', count: 7, price: 0.55, discount: 3 },
            ];

            function toCurrency(amount, currency='USD') {
                return new Intl.NumberFormat('en', {
                    style: 'currency',
                    currency: currency
                }).format(amount);
            }

            function populateRow(product) {
                const cost = product.count * product.price * (1 - product.discount/100);
                const tr = document.createElement('tr');
                tr.innerHTML = `
                    <td>${product.article}</td> 
                    <td>${product.count}</td> 
                    <td>${toCurrency(product.price)}</td> 
                    <td>${product.discount}%</td> 
                    <td>${toCurrency(cost)}</td> 
                `.replace(/[\s\n\r]+/, '');
                return [tr, cost];
            }

            function populate(tblBody, articles=cart) {
                let sumCost = 0;
                articles.forEach(a => {
                    const [tr, cost] = populateRow(a);
                    tblBody.appendChild(tr);
                    sumCost += cost;
                });

                document.querySelector('#subtotal').innerText = toCurrency(sumCost);
                
                const vatPercent = 25;
                document.querySelector('#vatPercent').innerText = `${vatPercent}%`;
                document.querySelector('#vatAmount').innerText = toCurrency(sumCost * vatPercent/100);
                document.querySelector('#total').innerText = toCurrency(sumCost * (1 + vatPercent/100));
            }

            populate(document.querySelector('tbody'));
        </script>
    </body>
</html>
